package javax.xml.stream.util;

import javax.xml.stream.Location;
import javax.xml.namespace.QName;
import javax.xml.namespace.NamespaceContext;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.XMLStreamReader;

public class StreamReaderDelegate implements XMLStreamReader
{
    private XMLStreamReader reader;
    
    public StreamReaderDelegate() {
    }
    
    public StreamReaderDelegate(XMLStreamReader reader) {
        this.reader = reader;
    }
    
    public void setParent(XMLStreamReader reader) {
        this.reader = reader;
    }
    
    public XMLStreamReader getParent() {
        return this.reader;
    }
    
    @Override
    public int next() throws XMLStreamException {
        return this.reader.next();
    }
    
    @Override
    public int nextTag() throws XMLStreamException {
        return this.reader.nextTag();
    }
    
    @Override
    public String getElementText() throws XMLStreamException {
        return this.reader.getElementText();
    }
    
    @Override
    public void require(int type, String namespaceURI, String localName) throws XMLStreamException {
        this.reader.require(type, namespaceURI, localName);
    }
    
    @Override
    public boolean hasNext() throws XMLStreamException {
        return this.reader.hasNext();
    }
    
    @Override
    public void close() throws XMLStreamException {
        this.reader.close();
    }
    
    @Override
    public String getNamespaceURI(String prefix) {
        return this.reader.getNamespaceURI(prefix);
    }
    
    @Override
    public NamespaceContext getNamespaceContext() {
        return this.reader.getNamespaceContext();
    }
    
    @Override
    public boolean isStartElement() {
        return this.reader.isStartElement();
    }
    
    @Override
    public boolean isEndElement() {
        return this.reader.isEndElement();
    }
    
    @Override
    public boolean isCharacters() {
        return this.reader.isCharacters();
    }
    
    @Override
    public boolean isWhiteSpace() {
        return this.reader.isWhiteSpace();
    }
    
    @Override
    public String getAttributeValue(String namespaceUri, String localName) {
        return this.reader.getAttributeValue(namespaceUri, localName);
    }
    
    @Override
    public int getAttributeCount() {
        return this.reader.getAttributeCount();
    }
    
    @Override
    public QName getAttributeName(int index) {
        return this.reader.getAttributeName(index);
    }
    
    @Override
    public String getAttributePrefix(int index) {
        return this.reader.getAttributePrefix(index);
    }
    
    @Override
    public String getAttributeNamespace(int index) {
        return this.reader.getAttributeNamespace(index);
    }
    
    @Override
    public String getAttributeLocalName(int index) {
        return this.reader.getAttributeLocalName(index);
    }
    
    @Override
    public String getAttributeType(int index) {
        return this.reader.getAttributeType(index);
    }
    
    @Override
    public String getAttributeValue(int index) {
        return this.reader.getAttributeValue(index);
    }
    
    @Override
    public boolean isAttributeSpecified(int index) {
        return this.reader.isAttributeSpecified(index);
    }
    
    @Override
    public int getNamespaceCount() {
        return this.reader.getNamespaceCount();
    }
    
    @Override
    public String getNamespacePrefix(int index) {
        return this.reader.getNamespacePrefix(index);
    }
    
    @Override
    public String getNamespaceURI(int index) {
        return this.reader.getNamespaceURI(index);
    }
    
    @Override
    public int getEventType() {
        return this.reader.getEventType();
    }
    
    @Override
    public String getText() {
        return this.reader.getText();
    }
    
    @Override
    public int getTextCharacters(int sourceStart, char[] target, int targetStart, int length) throws XMLStreamException {
        return this.reader.getTextCharacters(sourceStart, target, targetStart, length);
    }
    
    @Override
    public char[] getTextCharacters() {
        return this.reader.getTextCharacters();
    }
    
    @Override
    public int getTextStart() {
        return this.reader.getTextStart();
    }
    
    @Override
    public int getTextLength() {
        return this.reader.getTextLength();
    }
    
    @Override
    public String getEncoding() {
        return this.reader.getEncoding();
    }
    
    @Override
    public boolean hasText() {
        return this.reader.hasText();
    }
    
    @Override
    public Location getLocation() {
        return this.reader.getLocation();
    }
    
    @Override
    public QName getName() {
        return this.reader.getName();
    }
    
    @Override
    public String getLocalName() {
        return this.reader.getLocalName();
    }
    
    @Override
    public boolean hasName() {
        return this.reader.hasName();
    }
    
    @Override
    public String getNamespaceURI() {
        return this.reader.getNamespaceURI();
    }
    
    @Override
    public String getPrefix() {
        return this.reader.getPrefix();
    }
    
    @Override
    public String getVersion() {
        return this.reader.getVersion();
    }
    
    @Override
    public boolean isStandalone() {
        return this.reader.isStandalone();
    }
    
    @Override
    public boolean standaloneSet() {
        return this.reader.standaloneSet();
    }
    
    @Override
    public String getCharacterEncodingScheme() {
        return this.reader.getCharacterEncodingScheme();
    }
    
    @Override
    public String getPITarget() {
        return this.reader.getPITarget();
    }
    
    @Override
    public String getPIData() {
        return this.reader.getPIData();
    }
    
    @Override
    public Object getProperty(String name) {
        return this.reader.getProperty(name);
    }
}
